<?php

namespace common\modules\product\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\modules\product\models\ProductVariantType;

/**
 * ProductVariantTypeSearch represents the model behind the search form about `common\modules\product\models\ProductVariantType`.
 */
class ProductVariantTypeSearch extends ProductVariantType
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['product_variant_type_id'], 'integer'],
            [['name', 'name2'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = ProductVariantType::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'product_variant_type_id' => $this->product_variant_type_id,
        ]);

        $query->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'name2', $this->name2]);

        return $dataProvider;
    }
}
